
#define ML_RESET_ADDR        1
#define ML_RESET_POWER       2
#define ML_TIMESTAMP         4

//=============================================================================
///
//@Memo: XidarML bus state information.
/**
   All information for a 1-Wire bus.  All nodes, their states, and their
    topology.  Also the serial port's device name, file descriptor, 
    termios state, and serial_struct state.
*/
struct MLt {
    /// OS port.
   pMLPORT                 pmlport;
    /// Pointer list of all the nodes, sorted by name, address, and path.
   PL                      mlnode;
    /// The current working directory of the bus.
   pMLNODE                 cwd;
    /// Path to the cwd.
   MLPATH                  mlpath;
    /// Depth of the path.
   char                    mldepth;
    /// E.g. 386SX16 with 16450, one char per write.
   char                    mlslomo;
};
//=============================================================================

