#include <memory.h>

#ifndef _WINSOCKAPI_
#define FD_BITS 64
#define FD_BITS_PER_LONG (8*sizeof(unsigned long))
#define FD_DIM  (FD_BITS/FD_BITS_PER_LONG)
typedef struct {
   unsigned long       fd_set_bits[FD_DIM];
} fd_set;
#define FD_ZERO(pfd_sett) memset(pfd_sett, 0, sizeof(*pfd_sett));
#define FD_SET(fdd, pfd_sett) \
   (pfd_sett)->fd_set_bits[(fdd)/FD_BITS_PER_LONG] |= \
    (1<<((fdd)%FD_BITS_PER_LONG));
#define select bsd_select
int select(int nfd, fd_set *pfd_set_rd, fd_set *pfd_set_wr,
 fd_set *pfd_set_ex, struct timeval *timeout);

struct timeval {
   long                tv_sec;         /* seconds */
   long                tv_usec;        /* and microseconds */
};
struct timezone {
   int                 tz_minuteswest;
   int                 tz_dsttime;
};
#endif
int gettimeofday(struct timeval *tv, struct timezone *tz);

int find_next_zero_bit(void *ptr, unsigned count, unsigned offset);
//int find_first_zero_bit(void *ptr, unsigned count);
#define find_first_zero_bit(ptrr, countt) find_next_zero_bit(ptrr, countt, 0)
int clear_bit(int bit, void *ptr);
int set_bit(int bit, void *ptr);
int test_bit(int bit, void *ptr);

int read(int fd, char *buf, unsigned count);
#define strcasecmp stricmp
char *strsep(char **pstr, const char *delim);
int ConinPoll(int timeout);
char *ConinGets(char *buf);
