/*
    Copyright (c) 1997 Eliot W. Dudley.  All rights reserved.

       edudley@servtech.com
       XIDAR TECHNICS
       3388 STATE RT 370
       CATO NY  13033

*/
/*
       1-Wire, DS, DS1820, DS2405, DS2407, DS9097, and MicroLan
          are trademarks and/or registered trademarks of
                 Dallas Semiconductor Coporation
*/


#include <time.h>
#include <sys\timeb.h>

#include "msglue.h"

int 
gettimeofday(
   struct timeval                *tv, 
   struct timezone               *tz
) {
   struct timeb                   t;

   ftime(&t);
   tv->tv_sec = t.time ;
   tv->tv_usec = t.millitm * 1000;
   return 0;
}

int 
bsd_select(
   int                           nfd, 
   fd_set                       *pfd_set_rd, 
   fd_set                       *pfd_set_wr,
   fd_set                       *pfd_set_ex, 
   struct timeval               *timeout
) {
   FD_ZERO(pfd_set_rd);
   if (ConinPoll(999999)) {
      FD_SET(0, pfd_set_rd);
      return(1);
   }
   return(0);
}

int 
find_next_zero_bit(
   void *ptr, 
   unsigned count, 
   unsigned offset
) {
   unsigned                    j;
   unsigned                    i;
   unsigned                    bit;
   unsigned long int          *bits;
   unsigned long int           mask;

   for (
    bit = offset, 
    bits = ((unsigned long int *)ptr) + (offset / 32),
    j = 0; 
    j < (count + 31) / 32;
    ++j,
    ++bits
   ) {
      for (
       mask = 1 << (i = offset % 32);
       (bit < count) && (i < 32); 
       ++i, 
       mask <<= 1, 
       ++bit
      ) {
         if (!(mask & *bits)) {
            return(bit);
         }
      }
   }
   return(count);
}

int 
clear_bit(
   int bit, 
   void *ptr
) {
   int                         ret;
   unsigned long int          *bits;
   unsigned long int           mask;

   bits = ((unsigned long int *)ptr) + (bit / 32);
   ret = *bits & (mask = 1 << (bit % 32));
   *bits &= ~mask;
   return(!!ret);
}

int 
set_bit(
   int bit, 
   void *ptr
) {
   int                         ret;
   unsigned long int          *bits;
   unsigned long int           mask;

   bits = ((unsigned long int *)ptr) + (bit / 32);
   ret = *bits & (mask = 1 << (bit % 32));
   *bits |= mask;
   return(!!ret);
}

int 
test_bit(
   int bit, 
   void *ptr
) {
   unsigned long int          *bits;
   unsigned long int           mask;

   bits = ((unsigned long int *)ptr) + (bit / 32);
   return(!!(*bits & (mask = 1 << (bit % 32))));
}
